=== debian/changelog ===
hipsparse (6.4.3-1) unstable; urgency=medium

  * Upload to unstable
  * Remove inactive maintainers from uploaders
  * Update my email and copyright information
  * d/rules: fix path to build-time tests
  * d/rules: use CMAKE_SKIP_INSTALL_RPATH for build-time tests
  * d/control: remove B-D on rocm-device-libs-17
  * Fix FTBFS on unstable (Closes: #1120187)
    * Add python3-sphinxcontrib.htmlhelp to B-D for the docs
    * Add d/p/fix-improper-use-of-filesystem.patch to fix an improper
      redeclaration of std::filesystem in hipsparse-tests

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Fri, 07 Nov 2025 13:17:09 -0700

hipsparse (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3
  * Update d/gbp.conf to follow DEP-14
  * Improve the run-tests runner

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 10:50:21 +0200
