=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/libhipsparse1-tests/run-tests
Features: test-name=libhipsparse1-tests
Depends: pkg-rocm-tools, libhipsparse1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
