=== debian/watch ===
Version: 5

Source: https://github.com/rocm/hipsparse/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipsparse-$1.tar.gz%
